Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/PurchaseOrderEntry/FrmPurchaseOrderEntryAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/PurchaseOrderEntry/FrmPurchaseOrderEntryAuxiliary.cs	(revision 300)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/PurchaseOrderEntry/FrmPurchaseOrderEntryAuxiliary.cs	(revision 301)
@@ -65,7 +65,7 @@
             m_DspLabelCtrl[(int)DspLblCtrlName.CompleteDate] = label11;
         
             // ここで固定文字の表示
-            lblFixComment.Text = string.Format("※金額変更時の{0}は{1}％で手計算してください。"
+            lblFixComment.Text = string.Format("※金額変更時の{0}は{1}％で自動計算されます。"
                                                                 ,s_StatutoryWelfareName
                                                                 , CommonMotions.SystemMasterData.StatutoryWelfareRate.ToString("0.0"));
         }
@@ -659,6 +659,12 @@
                     TotalPrice += DetailRec.ExecutionAmount;
                     // 工事台帳行
                     CurRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value = DetailRec.LineCount;
+                    // 予算書金額
+                    CurRow.Cells[(int)DispDetailGridColumn.BudgetValue].Value = DetailRec.ExecutionAmount;
+                    // 前回入力値金額
+                    CurRow.Cells[(int)DispDetailGridColumn.PreviousValue].Value = DetailRec.ExecutionAmount;
+                    // データタイプ
+                    CurRow.Cells[(int)DispDetailGridColumn.DataType].Value = (int)PurchaseOrderDetail.DataTypeFlagDef.CommonData;
 
                     Linecnt++;
                 }
@@ -704,10 +710,8 @@
             DataGridView dgv = inputpage.Group1DataGridView;
             try
             {
-                // 法定福利費のセット 間違えて1/8にしていたため修正
-                //int WelfareValue = CommonMotions.cnvRound(TotalPrice / CommonMotions.SystemMasterData.StatutoryWelfareRate);
-                double dRate = (CommonMotions.SystemMasterData.StatutoryWelfareRate / 100);
-                int WelfareValue = CommonMotions.cnvRound(TotalPrice * dRate);
+                // 法定福利費のセット
+                int WelfareValue = CommonMotions.cnvRound(TotalPrice * m_dRate);
 
                 DataGridViewRow CurRow = dgv.Rows[Linecnt];
                 // 番号
@@ -730,7 +734,12 @@
                 CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value = WelfareValue.ToString("#,0");
                 // 元工事番号
                 CurRow.Cells[(int)DispDetailGridColumn.SourceCode].Value = 0;
+                // データタイプ
+                CurRow.Cells[(int)DispDetailGridColumn.DataType].Value = (int)PurchaseOrderDetail.DataTypeFlagDef.StatutoryWelfare;
 
+                // 法定福利費は計算のみなので行ロック
+                CurRow.ReadOnly = true;
+
                 // 元の工事金額より福利費を引く
                 //int SubtractionValue = CommonMotions.cnvRound(WelfareValue / Linecnt);
                 for (int i = 0; i < Linecnt; i++)
@@ -737,7 +746,7 @@
                 {
                     CurRow = dgv.Rows[i];
                     double work = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value);
-                    CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value = CommonMotions.cnvRound(work * (1 - dRate)).ToString("#,0");
+                    CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value = CommonMotions.cnvRound(work * (1 - m_dRate)).ToString("#,0");
                 }
 
                 return true;
@@ -784,14 +793,29 @@
                 this.TabCollections.TabPages.RemoveAt(0);
 
                 int icnt = 0;
+                ArrayList DetailData = new ArrayList();
                 foreach (PurchaseOrder OrderRec in OrderList)
                 {
-                    List<PurchaseOrderDetail> DetailData = new List<PurchaseOrderDetail>();
                     strSQL.Clear();
-                    strSQL.Append(DetailDB.CreatePrimarykeyString(OrderRec.ConstructionCode, OrderRec.SeqNo));
-                    strSQL.Append(" ORDER BY GroupCount ASC, LineCount ASC");
-                    if (!DetailDB.SelectAction(strSQL.ToString(), ref DetailData)) continue;
+                    strSQL.Append("Select");
+                    strSQL.Append(" A.*");
+                    strSQL.Append(", B.ExecutionAmount");
+                    strSQL.Append(" From");
+                    strSQL.Append(" purchaseorderdetail As A");
 
+                    strSQL.Append(" Left Join constructionledgerdetail As B");
+                    strSQL.Append("   On B.SourceCode = A.ConstructionCode");
+                    strSQL.Append("   And B.ConstructionCode = A.SourceCode");
+                    strSQL.Append("   And B.LineCount = A.SourceLineCnt");
+                    
+                    strSQL.Append(DetailDB.CreatePrimarykeyString(OrderRec.ConstructionCode, OrderRec.SeqNo, 0, 0, "A."));
+                    strSQL.AppendFormat(" And A.GroupCount in ({0}, {1})", (int)PurchaseOrderDetail.GroupCountDef.Detail
+                                                                        , (int)PurchaseOrderDetail.GroupCountDef.StatutoryWelfare);
+
+                    strSQL.Append(" ORDER BY A.GroupCount ASC, A.LineCount ASC");
+                    DetailData.Clear();
+                    if (!DetailDB.ExecuteReader(strSQL.ToString(), ref DetailData)) continue;
+
                     // ページ追加
                     PurchaseOrderInputPage inputpage = new PurchaseOrderInputPage();
                     CreateNewPage(ref inputpage, icnt, OrderRec.OrderSheetType);
@@ -803,7 +827,7 @@
                     // ページデータをセットする
                     SetPurchaseOrderPage(ref inputpage, OrderRec, icnt);
                     // 明細データをセットする
-                    SetPurchaseOrderDetail(ref inputpage, DetailData, icnt);
+                    SetPurchaseOrderDetail(ref inputpage, DetailData, icnt, DetailDB);
                     icnt++;
                 }
 
@@ -939,15 +963,22 @@
         /// 注文書明細データよりデータをセットする
         /// </summary>
         /// <returns></returns>
-        private void SetPurchaseOrderDetail(ref PurchaseOrderInputPage inputpage, List<PurchaseOrderDetail> DetailList, int PageCount)
+        private void SetPurchaseOrderDetail(ref PurchaseOrderInputPage inputpage
+                                            , ArrayList DetailList
+                                            , int PageCount
+                                            , IOPurchaseOrderDetail DetailDB)
         {
             try
             {
+                int DetailFeildCnt = Enum.GetNames(typeof(IOPurchaseOrderDetail.TableColumn)).Length;
                 // 明細グリッド表示
                 int iRow = 0;
                 double PriceValueValue = 0;
-                foreach (PurchaseOrderDetail DetailRec in DetailList)
+                PurchaseOrderDetail DetailRec = new PurchaseOrderDetail();
+                foreach (object[] ObjRec in DetailList)
                 {
+                    DetailDB.Reader2Struct(ObjRec, ref DetailRec);
+
                     // 明細データのみを対象にする
                     if (DetailRec.GroupCount != (int)PurchaseOrderDetail.GroupCountDef.Detail
                         && DetailRec.GroupCount != (int)PurchaseOrderDetail.GroupCountDef.StatutoryWelfare)
@@ -966,10 +997,19 @@
                     GetRow.Cells[(int)DispDetailGridColumn.PriceValue].Value = DetailRec.OrdersLinePrice.ToString("#,0");       // 金額
                     GetRow.Cells[(int)DispDetailGridColumn.SourceCode].Value = DetailRec.SourceCode;                            // 元工事番号
                     GetRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value = DetailRec.SourceLineCnt;                         // 元台帳行番号
+                    GetRow.Cells[(int)DispDetailGridColumn.DataType].Value = DetailRec.DataTypeFlag;                            // データタイプ
 
+                    GetRow.Cells[(int)DispDetailGridColumn.BudgetValue].Value = CommonMotions.cnvInt(ObjRec[DetailFeildCnt]);   // 予算書金額
+                    GetRow.Cells[(int)DispDetailGridColumn.PreviousValue].Value = CommonMotions.cnvDouble(ObjRec[DetailFeildCnt])
+                                                                                  * (1.0 - m_dRate);                            // 前回入力値金額
+
                     // 金額集計
                     PriceValueValue += DetailRec.OrdersLinePrice;
 
+                    // 法定福利費は行ロック
+                    if (DetailRec.DataTypeFlag == (int)PurchaseOrderDetail.DataTypeFlagDef.StatutoryWelfare)
+                        GetRow.ReadOnly = true;
+                        
                     iRow++;
                 }
                 // グリッド合計表示
@@ -978,8 +1018,10 @@
                 // 条件グリッド
                 iRow = Group4GridStaticString.Length;
 
-                foreach (PurchaseOrderDetail DetailRec in DetailList)
+                foreach (object[] ObjRec in DetailList)
                 {
+                    DetailDB.Reader2Struct(ObjRec, ref DetailRec);
+
                     DataGridViewRow GetRow = inputpage.Group4DataGridView.Rows[iRow];
                     // 条件データのみを対象にする
                     if (DetailRec.GroupCount == (int)PurchaseOrderDetail.GroupCountDef.Detail
@@ -1001,7 +1043,7 @@
         /// <summary>
         /// 台帳発注金額テーブル
         /// </summary>
-        private List<KeyValuePair<int, int>> LedgerOrderPrice = new List<KeyValuePair<int, int>>();
+        private List<KeyValuePair<int, int>> m_LedgerOrderPrice = new List<KeyValuePair<int, int>>();
         #endregion
 
         #region 台帳発注金額テーブル作成
@@ -1013,11 +1055,14 @@
             IOConstructionLedgerDetail LedgerDDB = new IOConstructionLedgerDetail();
             try
             {
-                LedgerOrderPrice.Clear();
+                m_LedgerOrderPrice.Clear();
 
                 StringBuilder strSQL = new StringBuilder();
-                strSQL.Append("SELECT COMPANYCODE, SUM(EXECUTIONAMOUNT) FROM CONSTRUCTIONLEDGERDETAIL");
-                strSQL.AppendFormat(" WHERE CONSTRUCTIONCODE = {0}", m_ConstructionCode);
+                strSQL.Append("SELECT");
+                strSQL.Append(" COMPANYCODE");
+                strSQL.Append(", SUM(EXECUTIONAMOUNT)");
+                strSQL.Append(" FROM CONSTRUCTIONLEDGERDETAIL");
+                strSQL.AppendFormat(" WHERE SOURCECODE = {0}", m_ConstructionCode);
                 strSQL.AppendFormat(" AND GROUPCOUNT = {0}", (int)FrmConstructionLedger.DataGroup.ConstructionCosts);
                 strSQL.AppendFormat(" AND PURCHASEORDERFLG = {0}", (int)ConstructionLedgerDetail.PurOrderFlgDef.Making);
                 strSQL.Append(" GROUP BY COMPANYCODE ORDER BY COMPANYCODE");
@@ -1025,7 +1070,7 @@
                 LedgerDDB.ExecuteReader(strSQL.ToString(), ref arList);
                 foreach (object[] objRec in arList)
                 {
-                    LedgerOrderPrice.Add(new KeyValuePair<int, int>(CommonMotions.cnvInt(objRec[0]), CommonMotions.cnvInt(objRec[1])));
+                    m_LedgerOrderPrice.Add(new KeyValuePair<int, int>(CommonMotions.cnvInt(objRec[0]), CommonMotions.cnvInt(objRec[1])));
                 }
             }
             catch (System.Exception ex)
@@ -1050,7 +1095,7 @@
             try
             {
                 int iRet = 0;
-                foreach (KeyValuePair<int, int> CurValue in LedgerOrderPrice)
+                foreach (KeyValuePair<int, int> CurValue in m_LedgerOrderPrice)
                 {
                     if (CompanyCode == CurValue.Key)
                     {
@@ -1212,19 +1257,21 @@
                     {
                         OrderDB.rollback();
                         DetailDB.rollback();
+                        LDetailDB.rollback();
                         return false;
                     }
 
                     // 注文書明細データ登録処理
-                    if (!EntryPurchaseOrderDetail(DetailDB, DataTab, SeqCnt))
+                    if (!EntryPurchaseOrderDetail(DetailDB, LDetailDB, DataTab, SeqCnt))
                     {
                         OrderDB.rollback();
                         DetailDB.rollback();
+                        LDetailDB.rollback();
                         return false;
                     }
 
                     // 工事台帳の注文書作成フラグ更新
-                    if (!UpdateLedgerDetail(LDetailDB, DataTab, SeqCnt))
+                    if (!UpdateLedgerDetail(LDetailDB, DataTab))
                     {
                         OrderDB.rollback();
                         DetailDB.rollback();
@@ -1612,7 +1659,10 @@
         /// 注文書明細データの登録処理
         /// </summary>
         /// <returns></returns>
-        private bool EntryPurchaseOrderDetail(IOPurchaseOrderDetail DetailDB, PurchaseOrderInputPage DataTab, int SeqNo)
+        private bool EntryPurchaseOrderDetail(IOPurchaseOrderDetail DetailDB
+                                                ,IOConstructionLedgerDetail LDetailDB
+                                                , PurchaseOrderInputPage DataTab
+                                                , int SeqNo)
         {
             try
             {
@@ -1631,6 +1681,16 @@
                         CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.Quantity].Value) == 0 &&
                         CommonMotions.cnvDouble(GetRow.Cells[(int)DispDetailGridColumn.PriceValue].Value) == 0) continue;
 
+                    // 業者変更時は台帳データを新規作成して行番号を取得する
+                    if (DataTab.CompanyChange
+                        && CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.GroupNo].Value) == (int)PurchaseOrderDetail.DataTypeFlagDef.CommonData)
+                    {
+                        // 元台帳行番号変更
+                        int nSourceLineCnt = 0;
+                        if (!CreateRowLedgerDetail(LDetailDB, DataTab, GetRow, ref nSourceLineCnt)) return false;
+                        GetRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value = nSourceLineCnt;
+                    }
+
                     PurchaseOrderDetail DatailRec = new PurchaseOrderDetail();
                     DatailRec.ConstructionCode = m_ConstructionCode;	                                                            // 工事番号
                     DatailRec.SeqNo = SeqNo;                                                                                        // 注文書枝番
@@ -1646,9 +1706,14 @@
                     DatailRec.OrdersLinePrice = CommonMotions.cnvDouble(GetRow.Cells[(int)DispDetailGridColumn.PriceValue].Value);  // 金額
                     DatailRec.SourceCode = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.SourceCode].Value);          // 元工事番号
                     DatailRec.SourceLineCnt = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value);       // 元台帳行番号
+                    DatailRec.DataTypeFlag = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.DataType].Value);          // データタイプ
 
                     // データ書込み
-                    if (!DetailDB.InsertAction(DatailRec, false)) return false;
+                    if (!DetailDB.InsertAction(DatailRec, false))
+                    {
+                        LogicalErrorMessage("注文書明細データ：明細登録に失敗しました。", "登録エラー", CommonMotions.GetMethodName());
+                        return false;
+                    }
                 }
 
                 // 簡易版と正規版ではグループ番号が違う
@@ -1679,7 +1744,7 @@
                     // データ書込み
                     if (!DetailDB.InsertAction(DatailRec, false))
                     {
-                        LogicalErrorMessage("注文書明細データ：登録に失敗しました。", "登録エラー", CommonMotions.GetMethodName());
+                        LogicalErrorMessage("注文書明細データ：条件登録に失敗しました。", "登録エラー", CommonMotions.GetMethodName());
                         return false;
                     }
                 }
@@ -1691,9 +1756,91 @@
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
                 return false;
             }
-            finally
+        }
+        #endregion
+
+        #region 業者変更時新規台帳行データ作成
+        /// <summary>
+        /// 業者変更時新規台帳行データ作成
+        /// </summary>
+        /// <returns></returns>
+        private bool CreateRowLedgerDetail(IOConstructionLedgerDetail LDetailDB
+                                            , PurchaseOrderInputPage DataTab
+                                            , DataGridViewRow GetRow
+                                            , ref int nLineCnt)
+        {
+            try
             {
+                StringBuilder strSQL = new StringBuilder();
+
+                // 台帳の追加行位置を取得する
+                int ConstrCode = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.SourceCode].Value);
+                int GrpCnt = (int)FrmConstructionLedger.DataGroup.ConstructionCosts;
+                int LedgerLineCnt = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value);
+                
+                strSQL.Append(LDetailDB.CreatePrimarykeyString(ConstrCode, GrpCnt));
+                nLineCnt = LDetailDB.SelectMaxLineCount(strSQL.ToString(), false) + 1;
+
+                strSQL.Clear();
+                strSQL.Append("Insert INTO ConstructionLedgerDetail");
+                strSQL.Append(" SELECT");
+                strSQL.Append(" A.ConstructionCode");                       // 工事番号
+                strSQL.Append(", A.GroupCount");                            // グループ番号
+                strSQL.AppendFormat(", {0}", nLineCnt);                     // 行番号
+                strSQL.Append(", A.ComponentCode");                         // 構成キー
+                strSQL.Append(", A.ItemCode");		                        // 工種キー
+                strSQL.Append(", A.FirstString");                           // 項目名称
+                strSQL.Append(", A.SecondString");                          // 工事内容
+                strSQL.Append(", A.CompanyType");                           // 協力会社コードタイプ
+                strSQL.AppendFormat(", {0}",DataTab.OrderCompanyCode);      // 協力会社コード
+                strSQL.Append(", B.CompanyName");                           // 協力会社名称
+                strSQL.Append(", A.EstimatePrice");                         // 予算（見積）金額
+                strSQL.Append(", A.ExecutionAmount");                       // 実行金額
+                strSQL.Append(", A.AmountConfigRate");                      // 金額構成率
+                strSQL.Append(", A.PaymentBurden");                         // 支払補填額
+                strSQL.Append(", A.FixDataFlg");                            // 固定データフラグ
+                strSQL.Append(", A.IndependentFlg");                        // 独立データフラグ
+                strSQL.Append(", A.FluctuationFlg");                        // 増減データフラグ
+                strSQL.Append(", A.SalaryFlg");                             // 給与振分区分
+                strSQL.Append(", A.SalaryDays");                            // 給与振分日数
+                strSQL.Append(", A.OperatingFlg");                          // 担当中フラグ
+                strSQL.Append(", A.SourceCode");                            // 元工事番号
+                strSQL.Append(", A.JoinTitleFlg");                          // 工事名称タイトル
+                strSQL.Append(", A.SalaryOnRegist");                        // 登録時月額給与
+                strSQL.AppendFormat(", {0}", (int)ConstructionLedgerDetail.PurOrderFlgDef.Making);  // 注文書発行フラグ
+                strSQL.AppendFormat(", STR_TO_DATE('{0}','%Y/%m/%d %H:%i:%s')", DateTime.Now);
+                strSQL.AppendFormat(", STR_TO_DATE('{0}','%Y/%m/%d %H:%i:%s')", DateTime.Now);
+                strSQL.Append(" FROM ConstructionLedgerDetail As A");
+                strSQL.Append(" Left Join subcontractormaster As B On B.CompanyCode = A.CompanyCode");
+
+                strSQL.Append(LDetailDB.CreatePrimarykeyString(ConstrCode, GrpCnt, LedgerLineCnt));
+
+                if (!LDetailDB.ExecuteNonQuery(strSQL.ToString(), false))
+                {
+                    LogicalErrorMessage("工事詳細台帳データ：新規行登録に失敗しました。", "登録エラー", CommonMotions.GetMethodName());
+                    return false;
+                }
+
+                // 変更前業者行更新
+                strSQL.Clear();
+                strSQL.Append(LDetailDB.CreatePrimarykeyString(ConstrCode, GrpCnt, LedgerLineCnt));
+                if (!LDetailDB.UpdateFeild(strSQL.ToString()
+                                            , (int)IOConstructionLedgerDetail.TableColumn.PurchaseOrderFlg
+                                            , (int)ConstructionLedgerDetail.PurOrderFlgDef.ChangeOld
+                                            , false))
+                {
+                    LogicalErrorMessage("注文書データ：業者変更フラグ更新に失敗しました。", "更新エラー", CommonMotions.GetMethodName());
+                    return false;
+                }
+
+
+                return true;
             }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
         }
         #endregion
 
@@ -1702,7 +1849,7 @@
         /// 工事台帳更新処理
         /// </summary>
         /// <returns></returns>
-        private bool UpdateLedgerDetail(IOConstructionLedgerDetail LDetailDB, PurchaseOrderInputPage DataTab, int SeqNo)
+        private bool UpdateLedgerDetail(IOConstructionLedgerDetail LDetailDB, PurchaseOrderInputPage DataTab)
         {
             try
             {
@@ -1709,21 +1856,14 @@
                 int QuantityVal = 0;
                 int PriceVal = 0;
                 int LedgerLine = 0;
-                bool ChangeCompany = false;
-                int BeforeCode = 0;
+                int TargetCode = 0;
                 StringBuilder strSQL = new StringBuilder();
-                int TargetCode = ClsProcessExist.GetParentConstrCode(m_ConstructionCode);
-                int TargetField = 0;
 
-                // 協力会社の変更チェック
-                ChangeCompany = ChangeCompanyTab(DataTab, ref  BeforeCode);
-
-                // 変更がない場合は処理しない
-                if (!ChangeCompany) return true;
-
                 DataGridView dgv = DataTab.Group1DataGridView;
                 foreach (DataGridViewRow CurRow in dgv.Rows)
                 {
+                    // 台帳工事番号
+                    TargetCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.SourceCode].Value);
                     // 数量
                     QuantityVal = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.Quantity].Value);
                     // 金額
@@ -1734,30 +1874,7 @@
                     if (QuantityVal == 0 && PriceVal == 0) continue;
                     if (LedgerLine == 0) continue;
 
-                    // ----- 変更がある場合は協力会社を対象外に変更し行追加
-                    // 協力会社名変更
-                    TargetField = (int)IOConstructionLedgerDetail.TableColumn.CompanyName;
-                    strSQL.Clear();
-                    strSQL.Append(LDetailDB.CreatePrimarykeyString(TargetCode));
-                    strSQL.AppendFormat(" AND SOURCECODE = {0}", m_ConstructionCode);
-                    strSQL.AppendFormat(" AND GROUPCOUNT = {0}", (int)FrmConstructionLedger.DataGroup.ConstructionCosts);
-                    strSQL.AppendFormat(" AND COMPANYCODE = {0}", BeforeCode);
-                    strSQL.AppendFormat(" AND LINECOUNT = {0}", LedgerLine);
-                    if (!LDetailDB.UpdateFeild(strSQL.ToString(), TargetField, DataTab.EntryTab.Text, false))
-                    {
-                        LogicalErrorMessage("注文書データ：協力会社名称変更に失敗しました。", "更新エラー", CommonMotions.GetMethodName());
-                        return false;
-                    }
-                    // 協力会社コード変更
-                    TargetField = (int)IOConstructionLedgerDetail.TableColumn.CompanyCode;
-                    if (!LDetailDB.UpdateFeild(strSQL.ToString(), TargetField, DataTab.OrderCompanyCode, false))
-                    {
-                        LogicalErrorMessage("注文書データ：協力会社コード変更に失敗しました。", "更新エラー", CommonMotions.GetMethodName());
-                        return false;
-                    }
-
                     // 注文書作成フラグON
-                    TargetField = (int)IOConstructionLedgerDetail.TableColumn.PurchaseOrderFlg;
                     strSQL.Clear();
                     strSQL.Append(LDetailDB.CreatePrimarykeyString(TargetCode));
                     strSQL.AppendFormat(" AND SOURCECODE = {0}", m_ConstructionCode);
@@ -1764,7 +1881,10 @@
                     strSQL.AppendFormat(" AND GROUPCOUNT = {0}", (int)FrmConstructionLedger.DataGroup.ConstructionCosts);
                     strSQL.AppendFormat(" AND COMPANYCODE = {0}", DataTab.OrderCompanyCode);
                     strSQL.AppendFormat(" AND LINECOUNT = {0}", LedgerLine);
-                    if (!LDetailDB.UpdateFeild(strSQL.ToString(), TargetField, (int)ConstructionLedgerDetail.PurOrderFlgDef.Making, false))
+                    if (!LDetailDB.UpdateFeild(strSQL.ToString()
+                                                , (int)IOConstructionLedgerDetail.TableColumn.PurchaseOrderFlg
+                                                , (int)ConstructionLedgerDetail.PurOrderFlgDef.Making
+                                                , false))
                     {
                         LogicalErrorMessage("注文書データ：注文書作成フラグ更新に失敗しました。", "更新エラー", CommonMotions.GetMethodName());
                         return false;
@@ -1771,8 +1891,6 @@
                     }
                 }
 
-                LDetailDB.commit();
-
                 return true;
             }
             catch (System.Exception ex)
@@ -1999,6 +2117,8 @@
                     btnApproval.ForeColor = Color.Black;
                     // 承認済みの場合は入力できない
                     DisplayReadOnly();
+
+                    m_bApprovalLock = true;
                 }
 
                 // 承認件数の表示
@@ -2102,7 +2222,7 @@
         /// 明細グリッド行計算処理
         /// </summary>
         /// <param name="dgv"></param>
-        private void CalculateDetailGridRow(DataGridView dgv)
+        private bool CalculateDetailGridRow(DataGridView dgv)
         {
             try
             {
@@ -2109,32 +2229,45 @@
                 DataGridViewRow CurRow = dgv.CurrentRow;
                 DataGridViewCell CurCell = dgv.CurrentCell;
 
-                bool bCalculate = false;
-                switch (CurCell.ColumnIndex)
+                double QuantityCount = CommonMotions.cnvDouble(CurRow.Cells[(int)DispDetailGridColumn.Quantity].Value);
+                double UnitPriceValue = CommonMotions.cnvDouble(CurRow.Cells[(int)DispDetailGridColumn.UnitPrice].Value);
+                double PriceValue = CommonMotions.cnvDouble(CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value);
+
+                // 明細以外は処理しない
+                int nDataType = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.DataType].Value);
+                if (nDataType != (int)PurchaseOrderDetail.DataTypeFlagDef.CommonData) return false;
+
+                // 対象以外は計算しない
+                if (CurCell.ColumnIndex != (int)DispDetailGridColumn.Quantity               // 数量
+                    && CurCell.ColumnIndex != (int)DispDetailGridColumn.UnitPrice           // 単価
+                    && CurCell.ColumnIndex != (int)DispDetailGridColumn.PriceValue)         // 金額
                 {
-                    case (int)DispDetailGridColumn.Quantity:            // 数量
-                    case (int)DispDetailGridColumn.UnitPrice:           // 単価
-                    case (int)DispDetailGridColumn.PriceValue:          // 金額
-                        bCalculate = true;
-                        break;
+                    return false;
                 }
-                // 対象以外は計算しない
-                if (!bCalculate) return;
-                double QuantityCount = CommonMotions.cnvDouble(CurRow.Cells[(int)DispDetailGridColumn.Quantity].Value);
-                double UnitPriceValue = CommonMotions.cnvDouble(CurRow.Cells[(int)DispDetailGridColumn.UnitPrice].Value);
-                double PriceValueValue = CommonMotions.cnvDouble(CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value);
+
                 // 単価があった場合は計算する
                 if (UnitPriceValue != 0)
                 {
-                    PriceValueValue = QuantityCount * UnitPriceValue;
+                    PriceValue = QuantityCount * UnitPriceValue;
                 }
+
+                // 入力値→前回入力値セット
+                CurRow.Cells[(int)DispDetailGridColumn.PreviousValue].Value = PriceValue;
+
+                // 法定福利費を引いた値をセットする
+                PriceValue = CommonMotions.cnvRound(PriceValue * (1.0 - m_dRate));
+
+                // 値のセット
                 CurRow.Cells[(int)DispDetailGridColumn.Quantity].Value = QuantityCount.ToString("#,#");
                 CurRow.Cells[(int)DispDetailGridColumn.UnitPrice].Value = UnitPriceValue.ToString("#,#");
-                CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value = PriceValueValue.ToString("#,#");
+                CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value = PriceValue.ToString("#,#");
+
+                return true;
             }
             catch (Exception ex)
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
             }
         }
         #endregion
@@ -2148,18 +2281,44 @@
         {
             try
             {
+                // 法定福利費行
+                int nStatutoryWelfareRow = -1;
                 // 合計金額を集計する
-                double PriceValueValue = 0;
+                double PriceValue = 0;
+                double CalcBaseValue = 0;
+                double wrkValue = 0;
                 foreach (DataGridViewRow CurRow in dgv.Rows)
                 {
+                    // 法定福利費以外を対象にする
+                    int nDataType = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.DataType].Value);
+                    if (nDataType == (int)PurchaseOrderDetail.DataTypeFlagDef.StatutoryWelfare)
+                    {
+                        // 法定福利費行取得
+                        nStatutoryWelfareRow = CurRow.Index;
+                        continue;
+                    }
+
                     // 金額を取得
-                    PriceValueValue += CommonMotions.cnvDouble(CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value);
+                    wrkValue = CommonMotions.cnvDouble(CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value);
+                    PriceValue += wrkValue;
+
+                    // 法定福利費計算ベース金額取得
+                    if (wrkValue != 0) CalcBaseValue += (wrkValue / (1.0 - m_dRate));
                 }
+
+                // 法定福利費をセットする
+                if (nStatutoryWelfareRow < 0) return;
+                DataGridViewRow SWRow = dgv.Rows[nStatutoryWelfareRow];
+
+                double dStatutoryWelfareVal = CommonMotions.cnvRound(CalcBaseValue * m_dRate);
+                SWRow.Cells[(int)DispDetailGridColumn.PriceValue].Value = dStatutoryWelfareVal.ToString("#,0");
+
                 int TabCnt = TabCollections.SelectedIndex;
                 PurchaseOrderInputPage CurPage = m_TabPageList[TabCnt];
 
                 // 合計欄の表示
-                CurPage.Group1Label.Text = PriceValueValue.ToString("#,0");
+                PriceValue+=dStatutoryWelfareVal;
+                CurPage.Group1Label.Text = PriceValue.ToString("#,0");
                 // 発注金額更新(発注金額は変更しない 2017/03/17)
                 //CurPage.PageValueItem[(int)PageValue.OrderPrice].Text = PriceValueValue.ToString("#,0");
 
